unit BackSWin;
// Project: CardDef LAC
// Copyright  2006-07 DSoft
// Uses CardDef DLL. CardDef  2003 DSoft

// Background select window
// Used by options window
  
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs;

type
  TBackSelectFrm = class(TForm)
    Panel1: TPanel;
    ColorBtn: TButton;
    BitmapBtn: TButton;
    SolidBack: TRadioButton;
    PictureBack: TRadioButton;
    Button3: TButton;
    Button4: TButton;
    ColorDialog1: TColorDialog;
    OpenDialog: TOpenPictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure SolidBackClick(Sender: TObject);
    procedure PictureBackClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ColorBtnClick(Sender: TObject);
    procedure BitmapBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    ReturnMode: integer;
    FileName: string;
    BackColor: TColor;
    BackColor2: TColor; // modified dialog is used for Score Background selection
    Canceled: boolean;
  end;

var
  BackSelectFrm: TBackSelectFrm;

implementation

{$R *.DFM}

procedure TBackSelectFrm.SolidBackClick(Sender: TObject);
begin
  PictureBack.Checked:= not SolidBack.Checked;
end;

procedure TBackSelectFrm.PictureBackClick(Sender: TObject);
begin
  SolidBack.Checked:= not PictureBack.Checked;
end;

procedure TBackSelectFrm.Button3Click(Sender: TObject);
begin
  BackColor:= ColorDialog1.Color;
  FileName:= OpenDialog.FileName;
  if SolidBack.Checked then ReturnMode:= 1 else ReturnMode:= 2;
  Canceled:= false;
  BackSelectFrm.Close;
end;

procedure TBackSelectFrm.Button4Click(Sender: TObject);
begin
  Canceled:= true;
  BackSelectFrm.Close;
end;

procedure TBackSelectFrm.ColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color:= BackColor;
  if ColorDialog1.Execute then
   BackColor:= ColorDialog1.Color;
end;

procedure TBackSelectFrm.FormCreate(Sender: TObject);
begin
  // obsolette (the color is now modded on ButtonClick directly
// ColorDialog1.Color:= BackColor;
end;

procedure TBackSelectFrm.BitmapBtnClick(Sender: TObject);
begin
  if not PictureBack.Enabled then
  begin
   ColorDialog1.Color:= BackColor2;
   if ColorDialog1.Execute then
    BackColor2:= ColorDialog1.Color
  end
  else begin
   if OpenDialog.Execute then
    FileName:= OpenDialog.FileName;
  end;
end;

end.
