unit Mainwin;
// Project: CardDef LAC
// Copyright  2006-07 DSoft
// Uses CardDef DLL. CardDef  2003 DSoft

// Interface Part
// This unit controls the whole game

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, IniFiles,
  StdCtrls, ExtCtrls, Menus, Carddefs, GameSyst, DXSounds, Grids, OptionsWin, CardSWin;

type
  TMainFrm = class(TForm)
    Panel1: TPanel;
    Card1: TImage;
    Card2: TImage;
    Card3: TImage;
    Card4: TImage;
    Card5: TImage;
    Card1Held: TLabel;
    Card2Held: TLabel;
    Card3Held: TLabel;
    Card4Held: TLabel;
    Card5Held: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    AddScoreBtn: TButton;
    ScoreLbl: TLabel;
    MinusesCount: TLabel;
    ScoreToAdd: TLabel;
    ThrowCardsBtn: TButton;
    Label4: TLabel;
    PlayerName: TLabel;
    Label5: TLabel;
    StatusLbl: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Load1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    New1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    Rules1: TMenuItem;
    AboutLuckyAces1: TMenuItem;
    AboutCardDef1: TMenuItem;
    Options1: TMenuItem;
    Environment1: TMenuItem;
    ScoreField: TStringGrid;
    Label6: TLabel;
    ScoreBackImg: TImage;
    CardBackImg: TImage;
    AppBackImg: TImage;
    procedure Environment1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure AddScoreBtnClick(Sender: TObject);
    procedure ThrowCardsBtnClick(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Dies: TDies;
    CurTurnValue: integer;
    CardBack: integer;
    UseAnims: boolean;
    UseSounds: boolean;
    CardSet: TCardSet;
    procedure ResetScoreList;
    procedure UpdateScoreList;
    procedure UpdateScore;
    procedure DrawDies(Dies: TDies);
    procedure ThrowCards(var Dies: TDies);
    procedure DisplayError(ErCode: integer);
    procedure DisplayMessage(Text: string; MCaption: string);
    procedure ReloadConfigFile;
    procedure UpdateWin;
  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

uses StartWin, MsgForm;

{$R *.DFM}


procedure TMainFrm.Environment1Click(Sender: TObject);
begin
  OptionsFrm.ShowModal;
  ReloadConfigFile;
end;

function Str8(E: string): string8;
var i: integer;
begin
 if Length(E) > 8 then
  for i:= 1 to 8 do
   Result:= Result + E[i];
 if Length(E) <= 8 then
  for i:= 1 to Length(E) do
    Result:= Result + E[i];
end;

function NameList(s1, s2, s3, s4: string8): TNames;
begin
  Result[1]:= s1;
  Result[2]:= s2;
  Result[3]:= s3;
  Result[4]:= s4;
end;

procedure TMainFrm.New1Click(Sender: TObject);
var i: integer;
begin
  StartGameFrm.ShowModal;
  if not (StartGameFrm.Canceled) then
  begin
    StartGame(StartGameFrm.NumOfPlayers.ItemIndex+2, NameList(StartGameFrm.Name1.Text,StartGameFrm.Name2.Text, StartGameFrm.Name3.Text, StartGameFrm.Name4.Text));
    ThrowCardsBtn.Enabled:= true;
    ResetScoreList;
    UpdateScoreList;
    for i:= 1 to 5 do
    begin
      Dies[i].Value:= 1;
      Dies[i].Held:= false;
    end;
    UpdateScore;
    DisplayMessage('It''s '+PlayerNames[CurPlayerIndex]+'''s turn','Information');
  end;
end;

procedure TMainFrm.DisplayMessage(Text: string; MCaption: string);
var Form: TMessageFrm;
begin
  Form:= TMessageFrm.Create(MainFrm);
  Form.CaptionLbl.Caption:= MCaption;
  Form.MsgLbl.Caption:= Text;
  Form.ShowModal;
  Form.Free;
end;

procedure TMainFrm.DisplayError(ErCode: integer);
var Form: TMessageFrm;
begin
  Form:= TMessageFrm.Create(MainFrm);
  Form.CaptionLbl.Caption:= 'ERROR';
  if ErCode = ER_FINISH then begin
    Form.CaptionLbl.Color:= clBlue;
    Form.CaptionLbl.Caption:= 'CONGRATS !';
  end
  else begin Form.CaptionLbl.Caption:= 'ERROR'; Form.CaptionLbl.Color:= clRed end;
  case ErCode of
    1: Form.MsgLbl.Caption:= MER_GATE;
    2: Form.MsgLbl.Caption:= Format(MER_SGATE, [50-CurrentScore(CurPlayerIndex)]);
    3: Form.MsgLbl.Caption:= MER_LGATE;
    4: Form.MsgLbl.Caption:= MER_FINISH;
    5: Form.MsgLbl.Caption:= MER_ZERO;
  end;
  Form.ShowModal;
  Form.Free;
end;

procedure TMainFrm.AddScoreBtnClick(Sender: TObject);
var Result: integer; i: integer; OutSc: boolean;
begin
  Result:= AddPoints(CurTurnValue, CurPlayerIndex);
  OutSc:= false;
  if Result > 0 then DisplayError(Result);
  if Result = ER_FINISH then begin
    FinishGame;
    AddScoreBtn.Enabled:= false;
    ThrowCardsBtn.Enabled:= false;
    Exit;
  end;
  for i:= 1 to NumPlayers do
  begin
    if i <> CurPlayerIndex then
    begin
      if CurrentScore(CurPlayerIndex) >= 50 then
       if (OutScored(CurPlayerIndex, i, CurTurnValue) and (CurrentScore(i) >= 50)) and (Result <= 0)  then
       begin
         AddPoints(-50, i);
         DisplayMessage('Player '+PlayerNames[i]+' is outscored and loses 50 points','Information');
         UpdateScoreList;
         OutSc:= true;
       end;
      // if OutSc then DisplayMessage(PENAL_3, 'Information');
    end;
  end;
  if Result > 0 then exit;
  NextTurn;
  AddScoreBtn.Enabled:= false;
  DisplayMessage('It''s '+PlayerNames[CurPlayerIndex]+'''s turn','Information');
  UpdateScore;
  UpdateScoreList;
  ClearDies(Dies);
  CurTurnValue:= 0;
end;

procedure TMainFrm.ThrowCardsBtnClick(Sender: TObject);
var s: integer;
begin
  ThrowCards(Dies);
  s:= TurnValue(Dies);
  if s = 0 then begin
    AddPoints(0, CurPlayerIndex);
    UpdateScore;
    DisplayMessage(PENAL_1, 'Information');
    if Minuses[CurPlayerIndex] = 3 then begin
      Minuses[CurPlayerIndex] := 0;
      AddPoints(-50, CurPlayerIndex);
      DisplayMessage(PENAL_2, 'Information');
    end;
    NextTurn;
    ClearDies(Dies);
    AddScoreBtn.Enabled:= false;
    DisplayMessage('It''s '+PlayerNames[CurPlayerIndex]+'''s turn','Information');
    if CurTurnValue <> 0 then UpdateScoreList;
    UpdateScore;
    CurTurnValue:= 0;
    Exit;
  end;
  CurTurnValue:= CurTurnValue + s;
  UpdateScore;
  AddScoreBtn.Enabled:= true;
end;

procedure TMainFrm.DrawDies(Dies: TDies);
begin
  Card1.Picture.Bitmap.Handle:= LoadImage(Dies[1].Value);
  Card2.Picture.Bitmap.Handle:= LoadImage(Dies[2].Value);
  Card3.Picture.Bitmap.Handle:= LoadImage(Dies[3].Value);
  Card4.Picture.Bitmap.Handle:= LoadImage(Dies[4].Value);
  Card5.Picture.Bitmap.Handle:= LoadImage(Dies[5].Value);
  Card1Held.Visible:= Dies[1].Held;
  Card2Held.Visible:= Dies[2].Held;
  Card3Held.Visible:= Dies[3].Held;
  Card4Held.Visible:= Dies[4].Held;
  Card5Held.Visible:= Dies[5].Held;
end;

procedure TMainFrm.ResetScoreList;
var i: integer;
begin
  for i:= 0 to NumPlayers-1 do
    ScoreField.Cells[i, 0]:= PlayerNames[i+1][1]+PlayerNames[i+1][2];
end;

procedure TMainFrm.UpdateScoreList;
var i, j: integer;
begin
  for i:= 0 to NumPlayers-1 do
    for j:= 1 to ScoreIndex[i+1] do
      ScoreField.Cells[i, j]:= IntToStr(Scores[i+1, j]);
end;

procedure TMainFrm.UpdateScore;
begin
  PlayerName.Caption:= PlayerNames[CurPlayerIndex];
  StatusLbl.Caption:= Format(PlayerScoringFormat(CurPlayerIndex), [CurrentScore(CurPlayerIndex)]);
  DrawDies(Dies);
  ScoreLbl.Caption:=  IntToStr(CurrentScore(CurPlayerIndex));
  MinusesCount.Caption:= IntToStr(Minuses[CurPlayerIndex]);
  ScoreToAdd.Caption:= IntToStr(CurTurnValue);
end;

procedure TMainFrm.ThrowCards(var Dies: TDies);
var i: integer; AllHeld: boolean;
begin
  AllHeld:= true;
  for i:= 1 to 5 do
   if not Dies[i].Held then AllHeld:= false;
  for i:= 1 to 5 do
   if (not Dies[i].Held) or (AllHeld) then begin
     Dies[i].Value:= Random(6)+1;
     if AllHeld then Dies[i].Held:= false;
  end;
end;

procedure TMainFrm.Save1Click(Sender: TObject);
begin
  ShowMessage('Not yet implemented. Sorry.');
end;

procedure TMainFrm.Load1Click(Sender: TObject);
begin
  ShowMessage('Not yet implemented. Sorry.');
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  if not LoadPreset(Solitaire) then Exit;
  Randomize;
end;

procedure TMainFrm.ReloadConfigFile;
var i: integer;
    IniFile: TMemIniFile;
begin
  IniFile:= TMemIniFile.Create(CfgFileName);
  UseSounds:= IniFile.ReadBool('Options', 'SoundEffects', true);

end;

end.
